<template>
    <b-container>
        <!-- Loading Screen -->
        <transition name="fadeloading">
            <loadingscreen v-show="loading"></loadingscreen>
        </transition>
        <!-- Header -->
        <div class="row my-3">
            <div class="col-md-8">
                <img src="../logo/vodafone_logo.svg" class="vodalogo mb-3" alt="Vodafone">
            </div>
            <div class="col-md-4">
                <b-form-input v-model="search" placeholder="Search for contact"></b-form-input>
            </div>
        </div>
        <!-- Body -->
        <div class="row mb-4">
            <div class="col-md-12 text-center">
                <h1 style="font-family: OpenSansBold !important;">Contacts</h1>
                <hr class="my-2 underline">
            </div>
        </div>
        <transition name="fadecontacts">
            <div v-show="!loading">
                <div class="row mb-4 px-2 justify-content-center">
                    <h2 class="mx-3 filterletter" :class="{red : letterToFilter === letter}" @click="filterByLetter(letter)" v-for="letter in letters">{{ letter }}</h2>
                </div>
                <div class="row">
                    <div v-for="contact in searchedContacts" class="col-md-4 mb-4">
                        <b-card :header="contact.name" class="text-center contactcard" header-bg-variant="dark" header-text-variant="white">
                            <div class="row mb-2"><div class="col-md-12 text-center text-muted">{{ contact['email'] }}</div></div>
                            <div class="row mb-3"><div class="col-md-12 text-center text-muted">{{ contact['phonenum'] }}</div></div>
                            <div class="row justify-content-center">
                                <b-button variant="primary" class="actionbutton viewbutton mx-2" @click="showModal(false, contact.id, true)" v-b-tooltip.hover.bottom title="View"><i class="fa fa-eye"></i></b-button>
                                <b-button variant="success" class="actionbutton editbutton mx-2 text-white"  @click="showModal(false, contact.id, false)" v-b-tooltip.hover.bottom title="Edit"><i class="fa fa-edit"></i></b-button>
                                <b-button variant="danger" class="actionbutton deletebutton mx-2" @click="del(contact['id'], contact['name'])" v-b-tooltip.hover.bottom title="Delete"><i class="fa fa-trash"></i></b-button>
                            </div>
                        </b-card>
                    </div>
                </div>
            </div>
        </transition>
        <!-- Modal for editing -->
        <b-modal
            :static="true"
            ref="contactmodal"
            id="contactmodal"
            centered
            hide-footer
            header-bg-variant="dark"
            header-text-variant="light"
            :title="modalTitle"
            :no-close-on-backdrop="true"
        >
            <vue-form-generator @validated="onValidated" :schema="schema" :model="model" :options="formOptions" ref="vfg"></vue-form-generator>
            <div class="row border-top pt-3 mt-3 justify-content-end">
                <loadingbutton :loadingprop="loadingbutton" v-if="!readonly" size="lg" class="mx-3 text-white" variant="success" :onClick="handleSubmit">{{ isCreate ? "Create Contact" : "Save Contact"}}</loadingbutton>
                <b-button  @click="cancel" class="ml-3 mr-4" variant="secondary">Cancel</b-button>
            </div>
        </b-modal>
        <!-- Delete confirmation modal -->
        <b-modal ref="deleteconfirm" @ok="handleDelete" title="Confirmation" header-bg-variant="danger" centered header-text-variant="light">
            {{ delConfirmationText }}
        </b-modal>
        <!-- Create contact buton -->
        <b-button variant="danger" class="createbutton" size="lg" @click="showModal(true, {}, false)"><i class="fa fa-plus"></i></b-button>
    </b-container>
</template>

<script>
    import axios from "axios";
    import loadingscreen from "./CustomComponents/LoadingScreen";
    import loadingbutton from "./CustomComponents/LoadingButton";
    import VueFormGenerator from "vue-form-generator";
    import formFields from "./Mixins/FormFields"

    export default {
        name: "App",
        mixins: [formFields],
        components: {"vue-form-generator": VueFormGenerator.component, loadingscreen, loadingbutton},
        data: () => {
            return {
                originalContacts: [],
                contacts: [],
                letters: [],
                loading: true,
                search: "",
                letterToFilter: "",
                modalTitle: "",
                model: {},
                isCreate: true,
                formOptions: {
                    validateAfterLoad: true,
                    validateAfterChanged: true
                },
                update_record: {},
                validated: false,
                loadingbutton: false,
                url: "api/contacts",
                delID: "",
                readonly: false,
                delConfirmationText: ""
            };
        },
        computed: {
            searchedContacts(){
                return(this.contacts.filter(el => {
                    return (
                        (el["name"].toLowerCase().includes(this.search.toLowerCase()) ||
                        el["email"].toLowerCase().includes(this.search.toLowerCase()) ||
                        el["phonenum"].toLowerCase().includes(this.search.toLowerCase()))
                    )
                }))
            },
        },
        methods: {
            getContacts(){
                //getting the contact from the DB
                //variable originalContacts stores the original list of contacts for filtering purposes
                this.loading = true;
                this.originalContacts = [];
                this.contacts = [];

                axios.get(this.url).then(response => {
                    this.originalContacts = response.data;
                    this.getLetters(this.originalContacts);
                    this.fetchContacts(this.originalContacts);
                    this.loading = false;
                })
                .catch(er => {
                    alert("Oops, something went wrong...");
                    console.log(er);
                })
            },
            getLetters(contacts){
                //get the first letter of every name and add it to the letter list if it is not there yet
                let letter;
                contacts.forEach(el => {
                    letter = el["name"].charAt(0).toUpperCase();
                    if(!this.letters.includes(letter)){
                        this.letters.push(letter);
                    }
                })
                this.letters.sort();
            },
            fetchContacts(contacts){
                //emptying the contacts array for a clear start
                this.contacts = [];
                //if we are filtering for a letter, than only add those contacts whose name starts with the letter
                if(this.letterToFilter === ""){
                    this.contacts = contacts;
                } else {
                    contacts.forEach(el => {
                        if(el["name"].charAt(0).toUpperCase() === this.letterToFilter){
                            this.contacts.push(el);
                        }
                    })
                }
            },
            filterByLetter(letter){
                //filtering by letters. If the clicked letter is actively filtering, switch it off
                this.letterToFilter === letter ? this.letterToFilter = "" : this.letterToFilter = letter;
                this.fetchContacts(this.originalContacts);
            },
            showModal(isCreate, id, readonly){
                //if the modal is opened for just viewing the contact, than make the fields disabled
                this.readonly = readonly;
                this.schema.fields.forEach(field => {
                    field["disabled"] = readonly;
                })

                //if the modal is opened for create new contact, than create and empty model, else open the contact by ID
                if(isCreate){
                    let tmp = {};
                    this.schema.fields.forEach(el => {
                        tmp[el.model] = null;
                    });
                    this.model = tmp;
                } else {
                    this.update_record = JSON.parse(JSON.stringify(this.originalContacts.find(el => el.id === id)));
                    this.model = this.update_record;
                }

                this.isCreate = isCreate;
                this.isCreate ? this.modalTitle = "Create Contact" : readonly ? this.modalTitle = this.model["name"] + "'s Profile" : this.modalTitle = "Edit Contact";
                this.$refs["contactmodal"].show();
                this.$refs.vfg.validate();
            },
            cancel(){
                //closing the modal and cleanup
                this.$refs["contactmodal"].hide();
                this.loadingbutton = false;
                this.update_record = {};
                this.model = {};
            },
            onValidated(isValid) {
                isValid ? this.validated = true : this.validated = false;
            },
            handleSubmit(){
                //if the form is valid, than if it is for creating a contact, than post request, if editing, than patch request
                //closing modal and refreshing the list after the request
                if (this.validated){
                    this.loadingbutton = true;

                    if(this.isCreate){
                        axios.post(this.url, this.model).then(() => {
                            this.cancel();
                            this.getContacts();
                        })
                        .catch(error => {
                            this.errorHandler(error);
                        })
                    } else {
                        axios.patch(this.url + '/' + this.update_record.id, this.model).then(() => {
                            this.cancel();
                            this.getContacts();
                        })
                        .catch(error => {
                            this.errorHandler(error);
                        })
                    }
                } else {
                    alert("Please fill out the required fields!")
                }
            },
            errorHandler(error){
                alert("Sorry, something went wrong");
                console.log(error.response);
                this.loadingbutton = false;
                this.cancel();
            },
            del(id, name) {
                //show the delete confirmation modal to confirm deleting
                this.delID = id;
                this.delConfirmationText = "Are you sure you want to delete the contact card of " + name + "?";
                this.$refs["deleteconfirm"].show();
            },
            handleDelete(evt){
                //delete the contact after confirmation
                evt.preventDefault();
                axios.delete(this.url + "/" + this.delID).then(() => {
                    this.getContacts();
                    this.$refs["deleteconfirm"].hide();
                });
            },
        },
        created(){
            this.getContacts();
        }
    };
</script>

<style>
    /* transitions for the loading panel and the contact list */
    .fadeloading-enter-active,
    .fadeloading-leave-active,
    .fadecontacts-enter-active,
    .fadecontacts-leave-active{
        transition: all 0.5s;
    }
    .fadeloading-enter,
    .fadeloading-leave-to,
    .fadecontacts-enter,
    .fadecontacts-leave-to {
        transform: translateY(20px) !important;
        opacity: 0;
    }
</style>
